org.scalatest.junit

# JUnitTestFailedError

#### class JUnitTestFailedError extends AssertionFailedError with StackDepth with ModifiableMessage[JUnitTestFailedError]

Exception that indicates a test failed.

The purpose of this exception is to encapsulate the same stack depth information provided by `TestFailedException`, which is used when running with ScalaTest, but be reported as a failure not an error when running with JUnit. The stack depth information indicates which line of test code failed, so that when running with ScalaTest information can be presented to the user that makes it quick to find the failing line of test code. (In other words, when running with ScalaTest the user need not scan through the stack trace to find the correct filename and line number of the failing test.)

JUnit distinguishes between failures and errors. If a test fails because of a failed assertion, that is considered a failure in JUnit. If a test fails for any other reason, either the test code or the application being tested threw an unexpected exception, that is considered an error in JUnit. This class differs from `TestFailedException` in that it extends `junit.framework.AssertionFailedError`. Instances of this class are thrown by the assertions provided by `AssertionsForJUnit`, and matcher expressions provided by `ShouldMatchersForJUnit`, and `MustMatchersForJUnit`.

The way JUnit 3 (JUnit 3.8 and earlier releases) decided whether an exception represented a failure or error is that only thrown `junit.framework.AssertionFailedError`s were considered failures. Any other exception type was considered an error. The exception type thrown by the JUnit 3 assertion methods declared in `junit.framework.Assert` (such as `assertEquals`, `assertTrue`, and `fail`) was, therefore, `AssertionFailedError`. In JUnit 4, `AssertionFailedError` was made to extend `java.lang.AssertionError`, and the distinction between failures and errors was essentially dropped. However, some tools that integrate with JUnit carry on this distinction, so even if you are using JUnit 4 you may want to use the "`ForJUnit`" of ScalaTest assertions and matchers.

Linear Supertypes
ModifiableMessage[JUnitTestFailedError], StackDepth, AssertionFailedError, AssertionError, Error, Throwable, Serializable, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. JUnitTestFailedError
2. ModifiableMessage
3. StackDepth
4. AssertionFailedError
5. AssertionError
6. Error
7. Throwable
8. Serializable
9. AnyRef
10. Any

Visibility

1. Public
2. All

### Instance Constructors

1. #### new JUnitTestFailedError (message: String, cause: Throwable, failedCodeStackDepth: Int)

   Create a `JUnitTestFailedError` with the specified stack depth, detail message, and cause.

   Create a `JUnitTestFailedError` with the specified stack depth, detail message, and cause.

   Note that the detail message associated with cause is not automatically incorporated in this throwable's detail message.

   message

     A detail message for this `JUnitTestFailedError`.

   cause

     the cause, the `Throwable` that caused this `JUnitTestFailedError` to be thrown.

   failedCodeStackDepth

     the depth in the stack trace of this exception at which the line of test code that failed resides.

2. #### new JUnitTestFailedError (cause: Throwable, failedCodeStackDepth: Int)

   Create a `JUnitTestFailedError` with the specified stack depth and cause.

   Create a `JUnitTestFailedError` with the specified stack depth and cause. The `message` field of this exception object will be initialized to `if (cause.getMessage == null) "" else cause.getMessage`.

   cause

     the cause, the `Throwable` that caused this `JUnitTestFailedError` to be thrown.

   failedCodeStackDepth

     the depth in the stack trace of this exception at which the line of test code that failed resides.

3. #### new JUnitTestFailedError (message: String, failedCodeStackDepth: Int)

   Create a `JUnitTestFailedError` with a specified stack depth and detail message.

   Create a `JUnitTestFailedError` with a specified stack depth and detail message.

   message

     A detail message for this `JUnitTestFailedError`.

   failedCodeStackDepth

     the depth in the stack trace of this exception at which the line of test code that failed resides.

4. #### new JUnitTestFailedError (failedCodeStackDepth: Int)

   Create a `JUnitTestFailedError` with specified stack depth and no detail message or cause.

   Create a `JUnitTestFailedError` with specified stack depth and no detail message or cause.

   failedCodeStackDepth

     the depth in the stack trace of this exception at which the line of test code that failed resides.

5. #### new JUnitTestFailedError (message: Option[String], cause: Option[Throwable], failedCodeStackDepth: Int)

   message

     an optional detail message for this `TestFailedException`.

   cause

     an optional cause, the `Throwable` that caused this `TestFailedException` to be thrown.

   failedCodeStackDepth

     the depth in the stack trace of this exception at which the line of test code that failed resides.

### Value Members

1. #### def != (arg0: AnyRef): Boolean

   Attributes
     final
   Definition Classes
     AnyRef

2. #### def != (arg0: Any): Boolean

   Attributes
     final
   Definition Classes
     Any

3. #### def ## (): Int

   Attributes
     final
   Definition Classes
     AnyRef → Any

4. #### def == (arg0: AnyRef): Boolean

   Attributes
     final
   Definition Classes
     AnyRef

5. #### def == (arg0: Any): Boolean

   Attributes
     final
   Definition Classes
     Any

6. #### def asInstanceOf [T0] : T0

   Attributes
     final
   Definition Classes
     Any

7. #### def canEqual (other: Any): Boolean

   Indicates whether this object can be equal to the passed object.

8. #### val cause : Option[Throwable]

   an optional cause, the `Throwable` that caused this `TestFailedException` to be thrown.

   an optional cause, the `Throwable` that caused this `TestFailedException` to be thrown.

   Definition Classes
     JUnitTestFailedError → StackDepth

9. #### def clone (): AnyRef

   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws()

10. #### def eq (arg0: AnyRef): Boolean

    Attributes
      final
    Definition Classes
      AnyRef

11. #### def equals (other: Any): Boolean

    Indicates whether this object is equal to the passed object.

    Indicates whether this object is equal to the passed object. If the passed object is a `JUnitTestFailedError`, equality requires equal `message`, `cause`, and `failedCodeStackDepth` fields, as well as equal return values of `getStackTrace`.

    Definition Classes
      JUnitTestFailedError → AnyRef → Any

12. #### def failedCodeFileName : Option[String]

    A string that provides the filename of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    A string that provides the filename of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    This is a `def` instead of a `val` because exceptions are mutable: their stack trace can be changed after the exception is created. This is done, for example, by the `SeveredStackTraces` trait.

    returns

      a string containing the filename that caused the failed test

    Definition Classes
      StackDepth

13. #### def failedCodeFileNameAndLineNumberString : Option[String]

    A string that provides the filename and line number of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    A string that provides the filename and line number of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    This is a `def` instead of a `val` because exceptions are mutable: their stack trace can be changed after the exception is created. This is done, for example, by the `SeveredStackTraces` trait.

    returns

      a user-presentable string containing the filename and line number that caused the failed test

    Definition Classes
      StackDepth

14. #### def failedCodeLineNumber : Option[Int]

    A string that provides the line number of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    A string that provides the line number of the line of code that failed, suitable for presenting to a user, which is taken from this exception's `StackTraceElement` at the depth specified by `failedCodeStackDepth`.

    This is a `def` instead of a `val` because exceptions are mutable: their stack trace can be changed after the exception is created. This is done, for example, by the `SeveredStackTraces` trait.

    returns

      a string containing the line number that caused the failed test

    Definition Classes
      StackDepth

15. #### val failedCodeStackDepth : Int

    the depth in the stack trace of this exception at which the line of test code that failed resides.

    the depth in the stack trace of this exception at which the line of test code that failed resides.

    Definition Classes
      JUnitTestFailedError → StackDepth

16. #### def fillInStackTrace (): Throwable

    Definition Classes
      Throwable

17. #### def finalize (): Unit

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()

18. #### def getCause (): Throwable

    Definition Classes
      Throwable

19. #### def getClass (): java.lang.Class[_]

    Attributes
      final
    Definition Classes
      AnyRef

20. #### def getLocalizedMessage (): String

    Definition Classes
      Throwable

21. #### def getMessage (): String

    Definition Classes
      Throwable

22. #### def getStackTrace (): Array[StackTraceElement]

    Definition Classes
      Throwable

23. #### def hashCode (): Int

    Returns a hash code value for this object.

    Returns a hash code value for this object.

    Definition Classes
      JUnitTestFailedError → AnyRef → Any

24. #### def initCause (throwable: Throwable): Throwable

    Attributes
      final
    Definition Classes
      JUnitTestFailedError → Throwable

25. #### def isInstanceOf [T0] : Boolean

    Attributes
      final
    Definition Classes
      Any

26. #### val message : Option[String]

    an optional detail message for this `TestFailedException`.

    an optional detail message for this `TestFailedException`.

    Definition Classes
      JUnitTestFailedError → StackDepth

27. #### def modifyMessage (fun: (Option[String]) ⇒ Option[String]): JUnitTestFailedError

    Returns an instance of this exception's class, identical to this exception, except with the detail message option string replaced with the result of passing the current detail message to the passed function, `fun`.

    Returns an instance of this exception's class, identical to this exception, except with the detail message option string replaced with the result of passing the current detail message to the passed function, `fun`.

    fun

      A function that, given the current optional detail message, will produce the modified optional detail message for the result instance of `TestFailedException`.

    Definition Classes
      JUnitTestFailedError → ModifiableMessage

28. #### def ne (arg0: AnyRef): Boolean

    Attributes
      final
    Definition Classes
      AnyRef

29. #### def notify (): Unit

    Attributes
      final
    Definition Classes
      AnyRef

30. #### def notifyAll (): Unit

    Attributes
      final
    Definition Classes
      AnyRef

31. #### def printStackTrace (arg0: PrintWriter): Unit

    Definition Classes
      Throwable

32. #### def printStackTrace (arg0: PrintStream): Unit

    Definition Classes
      Throwable

33. #### def printStackTrace (): Unit

    Definition Classes
      Throwable

34. #### def setStackTrace (arg0: Array[StackTraceElement]): Unit

    Definition Classes
      Throwable

35. #### def severedAtStackDepth : JUnitTestFailedError

    Returns an exception of class `JUnitTestFailedError` with `failedExceptionStackDepth` set to 0 and all frames above this stack depth severed off.

    Returns an exception of class `JUnitTestFailedError` with `failedExceptionStackDepth` set to 0 and all frames above this stack depth severed off. This can be useful when working with tools (such as IDEs) that do not directly support ScalaTest. (Tools that directly support ScalaTest can use the stack depth information delivered in the StackDepth exceptions.)

    Definition Classes
      JUnitTestFailedError → StackDepth

36. #### def synchronized [T0] (arg0: ⇒ T0): T0

    Attributes
      final
    Definition Classes
      AnyRef

37. #### def toString (): String

    Definition Classes
      Throwable → AnyRef → Any

38. #### def wait (): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

39. #### def wait (arg0: Long, arg1: Int): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

40. #### def wait (arg0: Long): Unit

    Attributes
      final
    Definition Classes
      AnyRef
    Annotations
      @throws()

### Inherited from ModifiableMessage[JUnitTestFailedError]

### Inherited from StackDepth

### Inherited from AssertionFailedError

### Inherited from AssertionError

### Inherited from Error

### Inherited from Throwable

### Inherited from Serializable

### Inherited from AnyRef

### Inherited from Any